unit courbe3d_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls,
  Math, Types;

type

  { TWdMain }

  TWdMain = class(TForm)
    CbAngle: TComboBox;
    CkRGB: TCheckBox;
    CkTrace: TCheckBox;
    EdSat: TEdit;
    EdLum: TEdit;
    EdZoom: TEdit;
    EdPts: TEdit;
    GrCoul: TGroupBox;
    GrRotations: TGroupBox;
    GrTr: TGroupBox;
    Img: TImage;
    LaAngle: TLabel;
    LaSat: TLabel;
    LaLum: TLabel;
    LaPts: TLabel;
    LaZoom: TLabel;
    Pa2: TPanel;
    Pa1: TPanel;
    PaAutoXYZ: TPanel;
    PaAutoXMoins: TPanel;
    PaAutoYMoins: TPanel;
    PaAutoZMoins: TPanel;
    PaAutoXPlus: TPanel;
    PaAutoYPlus: TPanel;
    PaAutoZPlus: TPanel;
    Rd4P: TRadioButton;
    RdP: TRadioButton;
    RdR: TRadioButton;
    SpObjet10: TSpeedButton;
    SpQuitter: TSpeedButton;
    SpRotZplus: TSpeedButton;
    SpRotYPlus: TSpeedButton;
    SpRotXPlus: TSpeedButton;
    SpRotXMoins: TSpeedButton;
    SpRotYMoins: TSpeedButton;
    SpRotZMoins: TSpeedButton;
    SpSatMoins: TSpeedButton;
    SpSatPlus: TSpeedButton;
    SpLumMoins: TSpeedButton;
    SpLumPlus: TSpeedButton;
    SpObjet5: TSpeedButton;
    SpObjet7: TSpeedButton;
    SpObj3: TSpeedButton;
    SpSauve: TSpeedButton;
    SpObj2: TSpeedButton;
    SpObj6: TSpeedButton;
    SpObj11: TSpeedButton;
    SpPlus: TSpeedButton;
    SpObj4: TSpeedButton;
    SpObj1: TSpeedButton;
    SpMoins: TSpeedButton;
    SpX90: TSpeedButton;
    SpY90: TSpeedButton;
    SpZ90: TSpeedButton;
    TiRotYMoins: TTimer;
    TiRotZMoins: TTimer;
    TiRotXMoins: TTimer;
    TiRotXYZ: TTimer;
    TiRotXPlus: TTimer;
    TiRotYPlus: TTimer;
    TiRotZPlus: TTimer;
    procedure CbAngleChange(Sender: TObject);
    procedure CkRGBChange(Sender: TObject);
    procedure CkTraceChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ImgMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure ImgMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure PaAutoXMoinsClick(Sender: TObject);
    procedure PaAutoXPlusClick(Sender: TObject);
    procedure PaAutoYMoinsClick(Sender: TObject);
    procedure PaAutoYPlusClick(Sender: TObject);
    procedure PaAutoZMoinsClick(Sender: TObject);
    procedure PaAutoXYZClick(Sender: TObject);
    procedure PaAutoZPlusClick(Sender: TObject);
    procedure Rd4PChange(Sender: TObject);
    procedure RdPChange(Sender: TObject);
    procedure RdRChange(Sender: TObject);
    procedure SpObjet5Click(Sender: TObject);
    procedure SpObjet10Click(Sender: TObject);
    procedure SpQuitterClick(Sender: TObject);
    procedure SpLumMoinsClick(Sender: TObject);
    procedure SpLumPlusClick(Sender: TObject);
    procedure SpRotXPlusClick(Sender: TObject);
    procedure SpRotYPlusClick(Sender: TObject);
    procedure SpRotZplusClick(Sender: TObject);
    procedure SpSatMoinsClick(Sender: TObject);
    procedure SpSatPlusClick(Sender: TObject);
    procedure SpObjet7Click(Sender: TObject);
    procedure SpObj3Click(Sender: TObject);
    procedure SpSauveClick(Sender: TObject);
    procedure SpObj2Click(Sender: TObject);
    procedure SpObj6Click(Sender: TObject);
    procedure SpObj11Click(Sender: TObject);
    procedure SpPlusClick(Sender: TObject);
    procedure SpObj4Click(Sender: TObject);
    procedure SpObj1Click(Sender: TObject);
    procedure SpRotXMoinsClick(Sender: TObject);
    procedure SpRotYMoinsClick(Sender: TObject);
    procedure SpRotZMoinsClick(Sender: TObject);
    procedure SpMoinsClick(Sender: TObject);
    procedure SpX90Click(Sender: TObject);
    procedure SpY90Click(Sender: TObject);
    procedure SpZ90Click(Sender: TObject);
    procedure TiRotXMoinsTimer(Sender: TObject);
    procedure TiRotXPlusTimer(Sender: TObject);
    procedure TiRotXYZTimer(Sender: TObject);
    procedure TiRotYMoinsTimer(Sender: TObject);
    procedure TiRotYPlusTimer(Sender: TObject);
    procedure TiRotZMoinsTimer(Sender: TObject);
    procedure TiRotZPlusTimer(Sender: TObject);
  private

  public

  end;

const
  NodesMax_ = 120000;
  //Angle de la scène
  AlphaDeg45_ = 45;
  AlphaRad45_ = 0.785398;
  //-
  AngleRad001_ = 0.017453;
  AngleRad003_ = 0.052360;
  AngleRad090_ = 1.570796;
  AngleRad270_ = 4.712389;
  AngleRad359_ = 6.265732;
  //-
  CubesMax_ = 100;
  SoMax_ = 8;

  HSL4_: array[1..4] of TColor = (
    //Blue,Red,Green,FuChSia
    240, 0, 120, 300
    );

type
  N3D_ = record
    x, y, z: double;
    //Couleur codée en HSL
    Hue: integer;
  end;

  N2D_ = record
    x, y: longword;
    //Couleur codée en HSL
    Hue: integer;
  end;

  Scene2D_ = record
    AlphaRad: double;
    //Maximum
    Xmax, Ymax: integer;
    //Décallage x,y,z
    Xd, Yd, Zdx, Zdy: integer;
    //Milieux
    Xm, Ym, Zm: integer;
  end;

  Nodes_ = record
    //Nbre de points
    Max: longword;
    //Data
    D3D: array[1..NodesMax_] of N3D_;
    D2D: array[1..NodesMax_] of N2D_;
    //Zoom
    Zoom: double;
  end;

var
  WdMain: TWdMain;
  DirExe: string;

implementation

{$R *.lfm}

{ TWdMain }

var
  //Scene
  Scene2D: Scene2D_;
  //Points
  Nodes: Nodes_;
  //Mode d'affichage (exemples ou cube)
  Mode: integer;
  //Couleurs
  Scol, Lcol: integer;

function RealToStr(Reel: double; Decimal: byte): string;
var
  s: string;
begin
  Str(Reel: 0: Decimal, s);
  Result := s;
end;

function StrToReal(Chaine: string): real;
var
  r: real;
  Pos: integer;
begin
  Val(Chaine, r, Pos);
  if Pos > 0 then
    Val(Copy(Chaine, 1, Pos - 1), r, Pos);
  Result := r;
end;

function IfChiffre(s: string): boolean;
var
  CptC: integer;
  CptP: integer;
  CptT: integer;
  n: integer;
  Ok: boolean;
begin
  CptC := 0;
  CptP := 0;
  CptT := 0;
  Ok := True;
  for n := 1 to Length(s) do
  begin
    case s[n] of
      //Chiffres
      '0'..'9': Inc(CptC);
      //Moins ou plus
      '-', '+': Inc(CptT);
      //Point de décimale
      '.': Inc(CptP);
      else
        Ok := False;
    end;
  end;
  //Test points
  if Ok then
  begin
    Ok := False;
    if (CptP < 2) and (CptT < 2) then
    begin
      if CptP + CptT + CptC = Length(s) then
      begin
        case CptT of
          0: Ok := True;
          1: if (s[1] = '-') or (s[1] = '+') then
              Ok := True;
        end;
      end;
    end;
  end;
  Result := Ok;
end;

procedure HSLtoRGB_H360_S100_L100_RGB255(H, S, L: integer; var R, G, B: byte);
var
  Sat, Lum: double;
begin
  //Entrée : H:0 à 360, S:0 à 100, L:0 à 100
  //Sortie : R:0 à 255, G:0 à 255, B:0 à 255
  R := 0;
  G := 0;
  B := 0;
  if ((H >= 0) and (H <= 359)) and ((S >= 0) and (S <= 100)) and
    ((L >= 0) and (L <= 100)) then
  begin
    if H <= 60 then
    begin
      R := 255;
      G := Round((255 / 60) * H);
      B := 0;
    end
    else if H <= 120 then
    begin
      R := Round(255 - (255 / 60) * (H - 60));
      G := 255;
      B := 0;
    end
    else if H <= 180 then
    begin
      R := 0;
      G := 255;
      B := Round((255 / 60) * (H - 120));
    end
    else if H <= 240 then
    begin
      R := 0;
      G := Round(255 - (255 / 60) * (H - 180));
      B := 255;
    end
    else if H <= 300 then
    begin
      R := Round((255 / 60) * (H - 240));
      G := 0;
      B := 255;
    end
    else if H <= 359 then
    begin
      R := 255;
      G := 0;
      B := Round(255 - (255 / 60) * (H - 300));
    end;

    Sat := Abs((S - 100) / 100);
    R := Round(R - ((R - 128) * Sat));
    G := Round(G - ((G - 128) * Sat));
    B := Round(B - ((B - 128) * Sat));
    Lum := (L - 50) / 50;

    if Lum > 0 then
    begin
      R := Round(R + ((255 - R) * Lum));
      G := Round(G + ((255 - G) * Lum));
      B := Round(B + ((255 - B) * Lum));
    end
    else if Lum < 0 then
    begin
      R := Round(R + (R * Lum));
      G := Round(G + (G * Lum));
      B := Round(B + (B * Lum));
    end;
  end;
end;


procedure Rotation_3D_X(Xi, Yi, Zi, AngleRad: double; Out Xo, Yo, Zo: double);
var
  Sa, Ca: double;
begin
  Sa := Sin(AngleRad);
  Ca := Cos(AngleRad);
  //-
  Xo := Xi;
  Yo := (Yi * Ca) - (Zi * Sa);
  Zo := (Yi * Sa) + (Zi * Ca);
end;

procedure Rotation_3D_Y(Xi, Yi, Zi, AngleRad: double; Out Xo, Yo, Zo: double);
var
  Sa, Ca: double;
begin
  Sa := Sin(AngleRad);
  Ca := Cos(AngleRad);
  //-
  Xo := (Xi * Ca) + (Zi * Sa);
  Yo := Yi;
  Zo := (Zi * Ca) - (Xi * Sa);
end;

procedure Rotation_3D_Z(Xi, Yi, Zi, AngleRad: double; Out Xo, Yo, Zo: double);
var
  Sa, Ca: double;
begin
  Sa := Sin(AngleRad);
  Ca := Cos(AngleRad);
  //-
  Xo := (Xi * Ca) - (Yi * Sa);
  Yo := (Xi * Sa) + (Yi * Ca);
  Zo := Zi;
end;

procedure Data3D_vers_Data2D(Pl3D: N3D_; AngleRad, Zoom: double; Out Pl2D: N2D_);
var
  AngleCosX: double;
  AngleSinY: double;
  z: double;
begin
  AngleCosX := Cos(AngleRad);
  AngleSinY := Sin(AngleRad);
  //-
  z := Pl3D.z * Nodes.Zoom;
  Pl2D.x := Round((Pl3D.x * Zoom) + (z * AngleCosX));
  Pl2D.y := Round((Pl3D.y * Zoom) + (z * AngleSinY));
  Pl2D.Hue := Pl3D.Hue;
end;

function Traceur: byte;
begin
  with WdMain do
  begin
    if RdP.Checked then
      Result := 1
    else
    begin
      if Rd4P.Checked then
        Result := 2
      else
        Result := 3;
    end;
  end;
end;

procedure Img_Clear;
var
  ADeg: integer;
  x: integer;
begin
  with WdMain do
  begin
    case CbAngle.ItemIndex of
      0: ADeg := 0;
      1: ADeg := 10;
      2: ADeg := 20;
      3: ADeg := 30;
      4: ADeg := 40;
      5: ADeg := 45;
      6: ADeg := 50;
      7: ADeg := 60;
      8: ADeg := 70;
      9: ADeg := 80;
      else
        ADeg := 0;
    end;
    with Img.Canvas do
    begin
      Pen.Color := ClCream;
      with Scene2D do
      begin
        //Angle de scène à x degrés
        AlphaRad := DegToRad(ADeg);
        for x := 0 to Xmax do
          Line(x, 0, x, Ymax);
        //Axes du milieu
        Pen.Color := ClSilver;
        Line(0, Ym, Xmax, Ym);
        Line(Xm, 0, Xm, Ymax);
      end;
    end;
  end;
end;

procedure Timer_Change(t0, t1, t2, t3, t4, t5, t6: boolean);
begin
  with WdMain do
  begin
    TiRotXYZ.Enabled := t0;
    TiRotXMoins.Enabled := t1;
    TiRotXPlus.Enabled := t2;
    TiRotYMoins.Enabled := t3;
    TiRotYPlus.Enabled := t4;
    TiRotZMoins.Enabled := t5;
    TiRotZPlus.Enabled := t6;
  end;
end;

procedure Auto_Change_Couleur(t0, t1, t2, t3, t4, t5, t6: byte);
begin
  with WdMain do
  begin
    case t0 of
      0: PaAutoXYZ.Color := ClCream;
      1: PaAutoXYZ.Color := ClLime;
    end;
    case t1 of
      0: PaAutoXMoins.Color := ClCream;
      1: PaAutoXMoins.Color := ClLime;
    end;
    case t2 of
      0: PaAutoXPlus.Color := ClCream;
      1: PaAutoXPlus.Color := ClLime;
    end;
    case t3 of
      0: PaAutoYMoins.Color := ClCream;
      1: PaAutoYMoins.Color := ClLime;
    end;
    case t4 of
      0: PaAutoYPlus.Color := ClCream;
      1: PaAutoYPlus.Color := ClLime;
    end;
    case t5 of
      0: PaAutoZMoins.Color := ClCream;
      1: PaAutoZMoins.Color := ClLime;
    end;
    case t6 of
      0: PaAutoZPlus.Color := ClCream;
      1: PaAutoZPlus.Color := ClLime;
    end;
  end;
end;

procedure SpBInit;
begin
  with WdMain do
  begin
    TiRotXYZ.Enabled := False;
    TiRotXPlus.Enabled := False;
    TiRotYPlus.Enabled := False;
    TiRotZPlus.Enabled := False;
  end;
end;

procedure SpB(OnOff: byte);
begin
  with WdMain do
  begin
    case OnOff of
      0:
      begin
        GrCoul.Enabled := False;
        GrTr.Enabled := False;
        GrRotations.Enabled := False;
        //Timer
        Timer_Change(False, False, False, False, False, False, False);
        Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
      end;
      1:
      begin
        GrCoul.Enabled := True;
        GrTr.Enabled := True;
        GrRotations.Enabled := True;
      end;
    end;
  end;
end;

procedure Objet_Lecture(Select: integer; Fichier: string);
var
  Txt: TextFile;
  s: string;
  Chf: array[1..3] of string;
  x, y, z: double;
  NbPts: longword;
  NbLg: longword;
  H, n, p: integer;
  Debut, Fin: boolean;
begin
  if FileExists(DirExe + Fichier) then
  begin
    H := 0;
    with WdMain do
    begin
      EdPts.Text := '';
      EdPts.Color := ClCream;
      EdZoom.Text := RealToStr(Nodes.Zoom, 2);
      H := 0;
      //-
      with Nodes do
      begin
        Zoom := 1;
        EdZoom.Text := RealToStr(Zoom, 2);
        Max := 0;
      end;
      //-
      AssignFile(Txt, DirExe + Fichier);
      {$i-}
      Reset(Txt);
      {$i+}
      if Ioresult = 0 then
      begin
        NbLg := 0;
        NbPts := 0;
        repeat
          {$i-}
          Readln(Txt, s);
          {$i+}
          if Ioresult = 0 then
          begin
            if s <> '' then
            begin
              Inc(NbLg);
              if s[1] = 'v' then
              begin
                for n := 1 to 3 do
                  Chf[n] := '';
                //-
                Debut := False;
                Fin := False;
                n := 2;
                p := 1;
                repeat
                  if p < 4 then
                  begin
                    if s[n] in ['-', '.', 'e', '0', '1', '2', '3',
                      '4', '5', '6', '7', '8', '9'] then
                    begin
                      case Debut of
                        False:
                        begin
                          Debut := True;
                          Chf[p] := s[n];
                        end;
                        else
                        begin
                          if not Fin then
                          begin
                            Chf[p] := Chf[p] + s[n];
                          end;
                        end;
                      end;
                    end
                    else
                    begin
                      if Debut then
                      begin
                        Inc(p);
                      end;
                      Debut := False;
                      Fin := False;
                    end;
                  end;
                  Inc(n);
                until n > Length(s);
                Inc(NbPts);
                if NbPts <= NodesMax_ then
                begin
                  x := 0;
                  if Chf[1] <> '' then
                    if IfChiffre(Chf[1]) then
                      x := StrToReal(Chf[1]);
                  y := 0;
                  if Chf[2] <> '' then
                    if IfChiffre(Chf[2]) then
                      y := StrToReal(Chf[2]);
                  z := 0;
                  if Chf[3] <> '' then
                    if IfChiffre(Chf[3]) then
                      z := StrToReal(Chf[3]);
                  //-
                  with Nodes do
                  begin
                    Inc(Max);
                    //X
                    D3D[Max].x := x;
                    //Y
                    D3D[Max].y := y;
                    //Z
                    D3D[Max].z := z;
                    //-
                    Max := NbPts;
                    D3D[Max].Hue := H;
                    H := H + 1;
                    if H > 360 then
                      H := 0;
                  end;
                end;
              end;
            end;
          end;
        until EOF(Txt);
        with Nodes do
        begin
          case Select of
            1: Zoom := 250;
            2: Zoom := 11;
          end;
          EdZoom.Text := RealToStr(Zoom, 2);
        end;
        if NbPts > NodesMax_ then
          ShowMessage('Avertissement : ' + IntToStr(NodesMax_) +
            ' / ' + IntToStr(NbPts) + ' ont été chargés...');
        EdPts.Text := IntToStr(Nodes.Max);
      end
      else
      begin
        ShowMessage('Erreur en ouverture du fichier "' + Fichier + '".');
      end;
      {$i-}
      CloseFile(Txt);
      {$i+}
    end;
  end
  else
  begin
    ShowMessage('Fichier "' + Fichier + '" introuvable.');
  end;
end;

procedure Sauvegarde_Format_O3D;
var
  Txt: TextFile;
  Fichier, s: string;
  n: longword;
  Lg: integer;
begin
  with WdMain do
  begin
    Lg:=0;
    Fichier := DirExe + 'Objet.O3D';
    AssignFile(Txt, Fichier);
    {$i-}
    Rewrite(Txt);
    {$i+}
    if Ioresult = 0 then
    begin
      with Nodes do
      begin
        for n := 1 to Max do
        begin
          s := 'v ' + RealToStr(D3D[n].x, 6) + ' ' + RealToStr(D3D[n].y, 6) +
            ' ' + RealToStr(D3D[n].z, 6);
          {$i-}
          Writeln(Txt, s);
          {$i+}
          if Ioresult=0 then
            Inc(Lg);
        end;
        ShowMessage('Données 3D (x,y,z) sauvées dans le fichier : "Objet.O3D"'+
                    #10#13+
                    'Le fichier propriétaire (.03D) est du type "Texte".'+
                    #10#13+
                    'Format ligne : "v x y z" sans la couleur.'+
                    #10#13+
                    IntToStr(Lg)+' lignes sauvegardées.');
      end;
    end else begin
      ShowMessage('Erreur en sauvegarde des données.');
    end;
    {$i-}
    CloseFile(Txt);
    {$i+}
  end;
end;

procedure Objets_Affiche;
var
  Col: TColor;
  n: longword;
  Sxy: array[1..SoMax_] of TPoint;
  p: integer;
  Tr, Nr: byte;
  R, G, B: byte;
begin
  with WdMain do
  begin
    if not CkTrace.Checked then
      Img_Clear;
    with Img.Canvas do
    begin
      with Nodes do
      begin
        R := 0;
        G := 0;
        B := 0;
        Tr := Traceur;
        Nr:=3;
        case Mode of
          0:
          begin
            for n := 1 to Max do
            begin
              //3D -> 2D
              Data3D_vers_Data2D(D3D[n], Scene2D.AlphaRad, Zoom, D2D[n]);
              if CkRGB.Checked then
              begin
                HSLtoRGB_H360_S100_L100_RGB255(D2D[n].Hue, Scol, Lcol, R, G, B);
                Col := RgbToColor(R, G, B);
              end
              else
              begin
                Col := ClBlack;
              end;
              //Largeur rectangle
              //-
              with Scene2D do
              begin
                case Tr of
                  1: Pixels[Xm + D2D[n].x, Ymax - (Ym + D2D[n].y)] := Col;
                  2:
                  begin
                    Pixels[Xm + Round(D2D[n].x), Ymax - (Ym + D2D[n].y - 1)] := Col;
                    Pixels[Xm + Round(D2D[n].x - 1), Ymax - (Ym + D2D[n].y)] := Col;
                    Pixels[Xm + Round(D2D[n].x + 1), Ymax - (Ym + D2D[n].y)] := Col;
                    Pixels[Xm + Round(D2D[n].x), Ymax - (Ym + D2D[n].y - 1)] := Col;
                  end;
                  3:
                  begin
                    Pen.Color := Col;
                    Rectangle(Xm + D2D[n].x - Nr, Ymax - (Ym + D2D[n].y - Nr),
                      Xm + D2D[n].x + Nr, Ymax - (Ym + D2D[n].y + Nr));
                  end;
                end;
              end;
            end;
            //-
          end;
          //Cubes
          1:
          begin
            n := 1;
            repeat
              with Scene2D do
              begin
                //Couleur pour le cube
                //1 seule pour 8 sommets
                for p := 1 to SoMax_ do
                begin
                  Data3D_vers_Data2D(D3D[n], Scene2D.AlphaRad, Zoom, D2D[n]);
                  Sxy[p].x := Xm + D2D[n].x;
                  Sxy[p].y := Ymax - (Ym + D2D[n].y);
                  Inc(n);
                end;
                if CkRGB.Checked then
                begin
                  HSLtoRGB_H360_S100_L100_RGB255(D2D[n].Hue, Scol, Lcol, R, G, B);
                  Col := RgbToColor(R, G, B);
                end
                else
                begin
                  Col := ClBlack;
                end;
                Pen.Color := Col;
                //Face avant 1-2
                Line(Sxy[1].x, Sxy[1].y, Sxy[2].x, Sxy[2].y);
                //Face avant 2-3
                Line(Sxy[2].x, Sxy[2].y, Sxy[3].x, Sxy[3].y);
                //Face avant 3-4
                Line(Sxy[3].x, Sxy[3].y, Sxy[4].x, Sxy[4].y);
                //Face avant 4-1
                Line(Sxy[4].x, Sxy[4].y, Sxy[1].x, Sxy[1].y);
                //Face arrière 5-6
                Line(Sxy[5].x, Sxy[5].y, Sxy[6].x, Sxy[6].y);
                //Face arrière 6-7
                Line(Sxy[6].x, Sxy[6].y, Sxy[7].x, Sxy[7].y);
                //Face arrière 7-8
                Line(Sxy[7].x, Sxy[7].y, Sxy[8].x, Sxy[8].y);
                //Face arrière 8-5
                Line(Sxy[8].x, Sxy[8].y, Sxy[5].x, Sxy[5].y);
                //Lien 1-5
                Line(Sxy[1].x, Sxy[1].y, Sxy[5].x, Sxy[5].y);
                //Lien 2-6
                Line(Sxy[2].x, Sxy[2].y, Sxy[6].x, Sxy[6].y);
                //Lien 3-7
                Line(Sxy[3].x, Sxy[3].y, Sxy[7].x, Sxy[7].y);
                //Lien 4-8
                Line(Sxy[4].x, Sxy[4].y, Sxy[8].x, Sxy[8].y);
              end;
            until n > Max;
          end;
        end;
      end;
    end;
  end;
end;

procedure Objet_Rotation(Axe: byte; AngleRad: double);
var
  n: longword;
begin
  with Nodes do
  begin
    for n := 1 to Max do
    begin
      case Axe of
        1: Rotation_3D_X(D3D[n].x, D3D[n].y, D3D[n].z, AngleRad,
            D3D[n].x, D3D[n].y, D3D[n].z);
        2: Rotation_3D_Y(D3D[n].x, D3D[n].y, D3D[n].z, AngleRad,
            D3D[n].x, D3D[n].y, D3D[n].z);
        3: Rotation_3D_Z(D3D[n].x, D3D[n].y, D3D[n].z, AngleRad,
            D3D[n].x, D3D[n].y, D3D[n].z);
      end;
    end;
  end;
  Objets_Affiche;
end;

procedure Hypotrochoide;
var
  Teta: double;
  H: integer;
begin
  SpB(0);
  Img_Clear;
  SpBInit;
  with WdMain do
  begin
    with Nodes do
    begin
      Zoom := 200;
      EdZoom.Text := RealToStr(Zoom, 2);
      H := 0;
      Max := 0;
      Teta := 0;
      repeat
        Inc(Max);
        //-
        D3D[Max].x := Power(Cos(Teta), 3);
        D3D[Max].y := Power(Sin(Teta), 3);
        D3D[Max].z := (Power(3, 0.5) / 2) * Sin(2 * Teta);
        //Couleur HSL
        D3D[Max].Hue := H;
        H := H + 1;
        if H > 360 then
          H := 0;
        //Angle
        Teta := Teta + 0.001;
      until Teta > 2 * Pi;
      EdPts.Text := IntToStr(Max);
    end;
  end;
  Mode := 0;
  Objets_Affiche;
  SpB(1);
end;

procedure Sinusoides;
var
  Teta: double;
  k, m, n: double;
  E1: double;
  H: integer;
begin
  SpB(0);
  Img_Clear;
  with WdMain do
  begin
    with Img.Canvas do
    begin
      Pen.Color := ClBlack;
      with Nodes do
      begin
        Zoom := 180;
        EdZoom.Text := RealToStr(Zoom, 2);
        m := 23;
        n := 15;
        k := 2;
        //-
        H := 0;
        Max := 0;
        Teta := 0;
        repeat
          Inc(Max);
          //-
          E1 := Power(1 + Power(k, 2) * Power(Sin(m * n), 2), 0.5);
          D3D[Max].x := Cos(n * Teta) / Power(E1, 0.5);
          D3D[Max].y := Sin(n * Teta) / Power(E1, 0.5);
          D3D[Max].z := Sin(m * Teta) / Power(E1, 0.5);
          //Couleur HSL
          D3D[Max].Hue := H;
          H := H + 1;
          if H > 360 then
            H := 0;
          //Angle
          Teta := Teta + 0.001;
        until Teta > 2 * Pi;
        EdPts.Text := IntToStr(Max);
      end;
    end;
  end;
  Mode := 0;
  Objets_Affiche;
  SpB(1);
end;

procedure Noeud;
var
  Teta: double;
  H: integer;
begin
  SpB(0);
  Img_Clear;
  with WdMain do
  begin
    with Img.Canvas do
    begin
      Pen.Color := ClBlack;
      with Nodes do
      begin
        Zoom := 30;
        EdZoom.Text := RealToStr(Zoom, 2);
        H := 0;
        Max := 0;
        Teta := 0;
        repeat
          Inc(Max);
          //-
          D3D[Max].x := (3 * Cos(Teta)) + (5 * Cos(3 * Teta));
          D3D[Max].y := (3 * Sin(Teta)) + (5 * Sin(3 * Teta));
          D3D[Max].z := (Sin(5 * Teta / 2) * Sin(3 * Teta)) +
            (Sin(4 * Teta) - Sin(6 * Teta));
          //Couleur HSL
          D3D[Max].Hue := H;
          H := H + 1;
          if H > 360 then
            H := 0;
          //Angle
          Teta := Teta + 0.001;
        until Teta > 4 * Pi;
        EdPts.Text := IntToStr(Max);
      end;
    end;
  end;
  Mode := 0;
  Objets_Affiche;
  SpB(1);
end;

procedure Solenoide;
var
  Teta: double;
  R1, r2, n: double;
  H: integer;
begin
  SpB(0);
  Img_Clear;
  with WdMain do
  begin
    with Img.Canvas do
    begin
      Pen.Color := ClBlack;
      with Nodes do
      begin
        Zoom := 10;
        EdZoom.Text := RealToStr(Zoom, 2);
        R1 := 17;
        r2 := 6;
        n := 30;
        //-
        H := 0;
        Max := 0;
        Teta := 0;
        repeat
          Inc(Max);
          //-
          D3D[Max].x := (R1 + r2 * Cos(n * Teta)) * Cos(Teta);
          D3D[Max].y := (R1 + r2 * Cos(n * Teta)) * Sin(Teta);
          D3D[Max].z := r2 * Sin(n * Teta);
          //Couleur HSL
          D3D[Max].Hue := H;
          H := H + 1;
          if H > 360 then
            H := 0;
          //Angle
          Teta := Teta + 0.001;
        until Teta > 2 * Pi;
        EdPts.Text := IntToStr(Max);
      end;
    end;
  end;
  Mode := 0;
  Objets_Affiche;
  SpB(1);
end;

procedure Cubes_Alea;
var
  Sb: array[1..SoMax_] of N3D_;
  n: longword;
  Px, Py, Pz: integer;
  p, q: integer;
begin
  SpB(0);
  Img_Clear;
  with WdMain do
  begin
    //Création du cube de base
    //Sommet 1
    Sb[1].x := -5;
    Sb[1].y := -5;
    Sb[1].z := -5;
    //Sommet 2
    Sb[2].x := -5;
    Sb[2].y := 5;
    Sb[2].z := -5;
    //Sommet 3
    Sb[3].x := 5;
    Sb[3].y := 5;
    Sb[3].z := -5;
    //Sommet 4
    Sb[4].x := 5;
    Sb[4].y := -5;
    Sb[4].z := -5;
    //Sommet 5
    Sb[5].x := -5;
    Sb[5].y := -5;
    Sb[5].z := 5;
    //Sommet 6
    Sb[6].x := -5;
    Sb[6].y := 5;
    Sb[6].z := 5;
    //Sommet 7
    Sb[7].x := 5;
    Sb[7].y := 5;
    Sb[7].z := 5;
    //Sommet 8
    Sb[8].x := 5;
    Sb[8].y := -5;
    Sb[8].z := 5;
    //-
    //H := 0;
    q := 1;
    with Nodes do
    begin
      Zoom := 1;
      EdZoom.Text := RealToStr(Zoom, 2);
      Max := 0;
    end;
    //-
    for n := 1 to CubesMax_ do
    begin
      //Position x,y,z d'un cube
      Px := Random(Round(Scene2D.Xmax / 4));
      p := Random(2);
      if p = 1 then
        Px := Px * -1;
      Py := Random(Round(Scene2D.Ymax / 3));
      p := Random(2);
      if p = 1 then
        Py := Py * -1;
      Pz := Random(Round(Scene2D.Ymax / 4));
      p := Random(2);
      if p = 1 then
        Pz := Pz * -1;
      //-
      if n = 1 then
      begin
        Px := 0;
        Py := 0;
        Pz := 0;
      end;
      with Nodes do
      begin
        for p := 1 to SoMax_ do
        begin
          Inc(Max);
          D3D[Max].x := Px + Sb[p].x;
          D3D[Max].y := Py + Sb[p].y;
          D3D[Max].z := Pz + Sb[p].z;
          D3D[Max].Hue := HSL4_[q];
        end;
        EdPts.Text := IntToStr(Max);
      end;
      Inc(q);
      if q > 4 then
        q := 1;
    end;
  end;
  //-
  Mode := 1;
  Objets_Affiche;
  SpB(1);
end;

procedure Astroide;
var
  Teta: double;
  a: double;
  H: integer;
begin
  SpB(0);
  Img_Clear;
  with WdMain do
  begin
    with Img.Canvas do
    begin
      Pen.Color := ClBlack;
      with Nodes do
      begin
        Zoom := 80;
        EdZoom.Text := RealToStr(Zoom, 2);
        //-
        H := 0;
        Max := 0;
        a := 2;
        Teta := 0;
        repeat
          Inc(Max);
          D3D[Max].x := a * Power(Cos(Teta), 3);
          D3D[Max].y := a * Power(Sin(Teta), 3);
          D3D[Max].z := a;
          //Couleur HSL
          D3D[Max].Hue := H;
          H := H + 1;
          if H > 360 then
            H := 0;
          //Angle
          Teta := Teta + 0.01;
          a := a - 0.001;
        until Teta > 12 * Pi;
        EdPts.Text := IntToStr(Max);
        //-
      end;
    end;
  end;
  Mode := 0;
  Objets_Affiche;
  SpB(1);
end;

procedure Spirale_Conique;
var
  Teta, Phi, Psi: double;
  k, m, u: double;
  H: integer;
begin
  SpB(0);
  Img_Clear;
  with WdMain do
  begin
    with Img.Canvas do
    begin
      Pen.Color := ClBlack;
      m := 3.5;
      Phi := DegToRad(40);
      Psi := DegToRad(80);
      k := Sin(Phi) * Cotan(Psi);
      Teta := 0;
      with Nodes do
      begin
        Zoom := 2;
        EdZoom.Text := RealToStr(Zoom, 2);
        H := 0;
        Max := 0;
        repeat
          Inc(Max);
          //-
          u := m * Exp(k * Teta);
          D3D[Max].x := u * Cos(Teta);
          D3D[Max].y := u * Sin(Teta);
          D3D[Max].z := u * 1.5 * Cos(Phi);
          //Couleur
          D3D[Max].Hue := H;
          H := H + 1;
          if H > 360 then
            H := 0;
          //Angle
          Teta := Teta + 0.05;
        until Teta > 10 * Pi;
        EdPts.Text := IntToStr(Max);
      end;
    end;
  end;
  Mode := 0;
  Objets_Affiche;
  SpB(1);
end;

procedure Spirale_Conique2;
var
  Teta, Phi: double;
  m, u: double;
  H: integer;
begin
  SpB(0);
  Img_Clear;
  with WdMain do
  begin
    with Img.Canvas do
    begin
      Pen.Color := ClBlack;
      m := 10;
      u := 2;
      Teta := 0;
      Phi := Pi / 2;
      with Nodes do
      begin
        Zoom := 1;
        EdZoom.Text := RealToStr(Zoom, 2);
        H := 0;
        Max := 0;
        repeat
          Inc(Max);
          //-
          D3D[Max].x := m * Sin(Phi) * Teta * Cos(Teta);
          D3D[Max].y := m * Sin(Phi) * Teta * Sin(Teta);
          D3D[Max].z := u * Cos(Phi) * Teta;
          //Couleur HSL
          D3D[Max].Hue := H;
          H := H + 1;
          if H > 360 then
            H := 0;
          //Angle
          Teta := Teta + 0.001;
        until Teta > 10 * Pi;
        EdPts.Text := IntToStr(Max);
      end;
    end;
  end;
  Mode := 0;
  Objets_Affiche;
  SpB(1);
end;

procedure Objet_O3D(Select: integer);
var
  Fichier: string;
begin
  SpB(0);
  Img_Clear;
  case Select of
    1: Fichier := 'Maya.O3D';
    2: Fichier := 'C3PO.O3D';
  end;
  Objet_Lecture(Select, Fichier);
  Mode := 0;
  //Objets_Affiche;
  with WdMain do
  begin
    CkRGB.Checked := False;
    RdP.Checked := True;
  end;
  Objets_Affiche;
  SpB(1);
end;

procedure Init_Img;
var
  z: double;
begin
  with WdMain do
  begin
    Mode := 0;
    //Couleurs
    Scol := 100;
    EdSat.Text := IntToStr(Scol);
    Lcol := 50;
    EdLum.Text := IntToStr(Lcol);
    //-
    with Scene2D do
    begin
      Xmax := Img.Width - 1;
      Ymax := Img.Height - 1;
      Xm := Xmax div 2;
      Ym := Ymax div 2;
      z := Power(Power(Xmax, 2) + Power(Ymax, 2), 0.5);
      Zm := Round(z / 2);
    end;
  end;
end;

procedure Auto_Affiche(Select: integer);
begin
  with WdMain do
  begin
    Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
    case Select of
      //Auto X-
      1: if TiRotXMoins.Enabled then
        begin
          Timer_Change(False, False, False, False, False, False, False);
        end
        else
        begin
          Auto_Change_Couleur(0, 1, 0, 0, 0, 0, 0);
          Timer_Change(False, True, False, False, False, False, False);
        end;
      //Auto X+
      2: if TiRotXPlus.Enabled then
        begin
          Timer_Change(False, False, False, False, False, False, False);
        end
        else
        begin
          Auto_Change_Couleur(0, 0, 1, 0, 0, 0, 0);
          Timer_Change(False, False, True, False, False, False, False);
        end;
      //Auto Y-
      3: if TiRotYMoins.Enabled then
        begin
          Timer_Change(False, False, False, False, False, False, False);
        end
        else
        begin
          Auto_Change_Couleur(0, 0, 0, 1, 0, 0, 0);
          Timer_Change(False, False, False, True, False, False, False);
        end;
      //Auto Y+
      4: if TiRotYPlus.Enabled then
        begin
          Timer_Change(False, False, False, False, False, False, False);
        end
        else
        begin
          Auto_Change_Couleur(0, 0, 0, 0, 1, 0, 0);
          Timer_Change(False, False, False, False, True, False, False);
        end;
      //Auto Z-
      5: if TiRotZMoins.Enabled then
        begin
          Timer_Change(False, False, False, False, False, False, False);
        end
        else
        begin
          Auto_Change_Couleur(0, 0, 0, 0, 0, 1, 0);
          Timer_Change(False, False, False, False, False, True, False);
        end;
      //Auto Z+
      6: if TiRotZPlus.Enabled then
        begin
          Timer_Change(False, False, False, False, False, False, False);
        end
        else
        begin
          Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 1);
          Timer_Change(False, False, False, False, False, False, True);
        end;
    end;
  end;
end;

procedure TWdMain.SpRotYMoinsClick(Sender: TObject);
begin
  Timer_Change(False, False, False, False, False, False, False);
  Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  Objet_Rotation(2, AngleRad001_);
end;

procedure TWdMain.SpRotZMoinsClick(Sender: TObject);
begin
  Timer_Change(False, False, False, False, False, False, False);
  Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  Objet_Rotation(3, AngleRad001_);
end;

procedure TWdMain.SpMoinsClick(Sender: TObject);
begin
  with Nodes do
  begin
    if Zoom > 1 then
    begin
      Zoom := Zoom - 1;
      EdZoom.Text := RealToStr(Zoom, 2);
    end;
  end;
  Objets_Affiche;
end;

procedure TWdMain.SpX90Click(Sender: TObject);
begin
  Timer_Change(False, False, False, False, False, False, False);
  Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  Objet_Rotation(1, AngleRad270_);
end;

procedure TWdMain.SpY90Click(Sender: TObject);
begin
  Timer_Change(False, False, False, False, False, False, False);
  Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  Objet_Rotation(2, AngleRad270_);
end;

procedure TWdMain.SpZ90Click(Sender: TObject);
begin
  Timer_Change(False, False, False, False, False, False, False);
  Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  Objet_Rotation(3, AngleRad270_);
end;

procedure TWdMain.TiRotXMoinsTimer(Sender: TObject);
begin
  Objet_Rotation(1, AngleRad001_);
end;

procedure TWdMain.TiRotXPlusTimer(Sender: TObject);
begin
  Objet_Rotation(1, AngleRad359_);
end;

procedure TWdMain.TiRotXYZTimer(Sender: TObject);
begin
  Objet_Rotation(1, AngleRad359_);
  Objet_Rotation(2, AngleRad359_);
  Objet_Rotation(3, AngleRad359_);
end;

procedure TWdMain.TiRotYMoinsTimer(Sender: TObject);
begin
  Objet_Rotation(2, AngleRad001_);
end;

procedure TWdMain.SpPlusClick(Sender: TObject);
begin
  with Nodes do
  begin
    Zoom := Zoom + 1;
    EdZoom.Text := RealToStr(Zoom, 2);
  end;
  Objets_Affiche;
end;

procedure TWdMain.SpObj4Click(Sender: TObject);
begin
  Sinusoides;
end;

procedure TWdMain.TiRotYPlusTimer(Sender: TObject);
begin
  Objet_Rotation(2, AngleRad359_);
end;

procedure TWdMain.TiRotZMoinsTimer(Sender: TObject);
begin
  Objet_Rotation(3, AngleRad359_);
end;

procedure TWdMain.TiRotZPlusTimer(Sender: TObject);
begin
  Objet_Rotation(3, AngleRad001_);
end;

procedure TWdMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  TiRotXYZ.Enabled := False;
end;

procedure TWdMain.CbAngleChange(Sender: TObject);
begin
  Objets_Affiche;
end;

procedure TWdMain.CkRGBChange(Sender: TObject);
begin
  Objets_Affiche;
end;

procedure TWdMain.CkTraceChange(Sender: TObject);
begin
  Objets_Affiche;
end;

procedure TWdMain.SpObj1Click(Sender: TObject);
begin
  Hypotrochoide;
end;

procedure TWdMain.SpRotXMoinsClick(Sender: TObject);
begin
  Timer_Change(False, False, False, False, False, False, False);
  Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  Objet_Rotation(1, AngleRad001_);
end;

procedure TWdMain.PaAutoXMoinsClick(Sender: TObject);
begin
  Auto_Affiche(1);
end;

procedure TWdMain.PaAutoXPlusClick(Sender: TObject);
begin
  Auto_Affiche(2);
end;

procedure TWdMain.PaAutoYMoinsClick(Sender: TObject);
begin
  Auto_Affiche(3);
end;

procedure TWdMain.PaAutoYPlusClick(Sender: TObject);
begin
  Auto_Affiche(4);
end;

procedure TWdMain.PaAutoZMoinsClick(Sender: TObject);
begin
  Auto_Affiche(5);
end;

procedure TWdMain.PaAutoXYZClick(Sender: TObject);
begin
  if TiRotXYZ.Enabled then
  begin
    TiRotXYZ.Enabled := False;
    Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  end
  else
  begin
    Timer_Change(True, False, False, False, False, False, False);
    Auto_Change_Couleur(1, 0, 0, 0, 0, 0, 0);
  end;
end;

procedure TWdMain.PaAutoZPlusClick(Sender: TObject);
begin
  Auto_Affiche(6);
end;

procedure TWdMain.Rd4PChange(Sender: TObject);
begin
  Objets_Affiche;
end;

procedure TWdMain.RdPChange(Sender: TObject);
begin
  Objets_Affiche;
end;

procedure TWdMain.RdRChange(Sender: TObject);
begin
  Objets_Affiche;
end;

procedure TWdMain.SpObjet5Click(Sender: TObject);
begin
  Astroide;
end;

procedure TWdMain.SpObjet10Click(Sender: TObject);
begin
  Objet_O3D(1);
end;

procedure TWdMain.SpQuitterClick(Sender: TObject);
begin
  WdMain.Close;
end;

procedure TWdMain.SpLumMoinsClick(Sender: TObject);
begin
  if Lcol > 5 then
  begin
    Dec(Lcol, 5);
    EdLum.Text := IntToStr(Lcol);
    Objets_Affiche;
  end;
end;

procedure TWdMain.SpLumPlusClick(Sender: TObject);
begin
  if Lcol <= 95 then
  begin
    Inc(Lcol, 5);
    EdLum.Text := IntToStr(Lcol);
    Objets_Affiche;
  end;
end;

procedure TWdMain.SpRotXPlusClick(Sender: TObject);
begin
  Timer_Change(False, False, False, False, False, False, False);
  Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  Objet_Rotation(1, AngleRad359_);
end;

procedure TWdMain.SpRotYPlusClick(Sender: TObject);
begin
  Timer_Change(False, False, False, False, False, False, False);
  Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  Objet_Rotation(2, AngleRad359_);
end;

procedure TWdMain.SpRotZplusClick(Sender: TObject);
begin
  Timer_Change(False, False, False, False, False, False, False);
  Auto_Change_Couleur(0, 0, 0, 0, 0, 0, 0);
  Objet_Rotation(3, AngleRad359_);
end;

procedure TWdMain.SpSatMoinsClick(Sender: TObject);
begin
  if Scol > 5 then
  begin
    Dec(Scol, 5);
    EdSat.Text := IntToStr(Scol);
    Objets_Affiche;
  end;
end;

procedure TWdMain.SpSatPlusClick(Sender: TObject);
begin
  if Scol <= 95 then
  begin
    Inc(Scol, 5);
    EdSat.Text := IntToStr(Scol);
    Objets_Affiche;
  end;
end;

procedure TWdMain.SpObjet7Click(Sender: TObject);
begin
  Cubes_Alea;
end;

procedure TWdMain.SpObj3Click(Sender: TObject);
begin
  Solenoide;
end;

procedure TWdMain.SpSauveClick(Sender: TObject);
begin
  Sauvegarde_Format_O3D;
end;

procedure TWdMain.SpObj2Click(Sender: TObject);
begin
  Noeud;
end;

procedure TWdMain.SpObj6Click(Sender: TObject);
begin
  Spirale_Conique;
end;

procedure TWdMain.SpObj11Click(Sender: TObject);
begin
  Objet_O3D(2);
end;

procedure TWdMain.ImgMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: boolean);
begin
  with Nodes do
  begin
    if Zoom > 1 then
    begin
      Zoom := Zoom - 1;
      EdZoom.Text := RealToStr(Zoom, 2);
    end;
  end;
  Objets_Affiche;
end;

procedure TWdMain.ImgMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: boolean);
begin
  with Nodes do
  begin
    Zoom := Zoom + 1;
    EdZoom.Text := RealToStr(Zoom, 2);
  end;
  Objets_Affiche;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  DirExe := ExtractFilePath(Application.ExeName);
  if DirExe[Length(DirExe)] <> '\' then
    DirExe := DirExe + '\';
  Init_Img;
  Img_Clear;
  Hypotrochoide;
end;

end.
